# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataShare::Mgmt::V2018_11_01_preview
  module Models
    #
    # A share subscription data transfer object.
    #
    class ShareSubscription < ProxyDto

      include MsRestAzure

      # @return [DateTime] Time at which the share subscription was created.
      attr_accessor :created_at

      # @return [String] The user who created the share subscription.
      attr_accessor :created_by

      # @return [String] The invitation id.
      attr_accessor :invitation_id

      # @return [ProvisioningState] Provisioning state of the share
      # subscription. Possible values include: 'Succeeded', 'Creating',
      # 'Deleting', 'Moving', 'Failed'
      attr_accessor :provisioning_state

      # @return [String] Description of share
      attr_accessor :share_description

      # @return [ShareKind] Kind of share. Possible values include: 'CopyBased'
      attr_accessor :share_kind

      # @return [String] Name of the share
      attr_accessor :share_name

      # @return [String] Sender of the share
      attr_accessor :share_sender

      # @return [String] Company name of the share sender
      attr_accessor :share_sender_company_name

      # @return [ShareSubscriptionStatus] Gets the current status of share
      # subscription. Possible values include: 'Active', 'Revoked',
      # 'SourceDeleted', 'Revoking'
      attr_accessor :share_subscription_status

      # @return [String] Terms of a share
      attr_accessor :share_terms


      #
      # Mapper for ShareSubscription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ShareSubscription',
          type: {
            name: 'Composite',
            class_name: 'ShareSubscription',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              created_at: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdAt',
                type: {
                  name: 'DateTime'
                }
              },
              created_by: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdBy',
                type: {
                  name: 'String'
                }
              },
              invitation_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.invitationId',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              share_description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareDescription',
                type: {
                  name: 'String'
                }
              },
              share_kind: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareKind',
                type: {
                  name: 'String'
                }
              },
              share_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareName',
                type: {
                  name: 'String'
                }
              },
              share_sender: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareSender',
                type: {
                  name: 'String'
                }
              },
              share_sender_company_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareSenderCompanyName',
                type: {
                  name: 'String'
                }
              },
              share_subscription_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareSubscriptionStatus',
                type: {
                  name: 'String'
                }
              },
              share_terms: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareTerms',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
